<template>
  <!-- Input wrapper -->
  <label
    :class="{
      ...getElementCssClass('wrapper'),
      ...getRootElementCSSClasses()
    }"
  >
    <!--
      @slot Label slot
    -->
    <slot name="label">
      <div
        v-if="label.length > 0"
        :class="getElementCssClass('label')"
      >
        {{ label }}{{ required ? ' *' : undefined }}
      </div>
    </slot>

    <!--
      @slot Input slot
    -->
    <slot name="input">
      <div class="relative">
        <t-input
          :ref="inputRef"
          :value="value"
          :name="name"
          :step="step"
          :min="minValue"
          :max="maxValue"
          :maxlength="maxlength"
          :type="type"
          :variant="variant"
          :fixed-classes="tInputStyle.fixedClasses"
          :classes="tInputStyle.classes"
          :variants="tInputStyle.variants"
          :required="required"
          :placeholder="placeholder"
          :autocomplete="autocomplete"
          :disabled="disabled"
          :pattern="pattern"
          :class="{
            'pr-10': (showValidatedIndicator || isLoading) ? true : false
          }"
          @input.native="nativeInputHandler"
        />
        <!--
          @slot Input button
        -->
        <slot name="inputButton">
          <!-- Loading icon -->
          <transition
            enter-active-class="_veryfast animated fadeIn"
            leave-active-class="_veryfast animated fadeOut"
          >
            <v-icon
              v-if="isLoading"
              name="spinner"
              class="absolute top-4 right-4"
              spin
            />
          </transition>
          <!-- Validated status icon -->
          <transition
            enter-active-class="_veryfast animated fadeIn"
            leave-active-class="_veryfast animated fadeOut"
          >
            <v-icon
              v-if="showValidatedIndicator && !isLoading"
              :name="validatedStatus ? 'check' : 'times'"
              :class="`absolute top-4 right-4 ${
                validatedStatus
                  ? '@light:text-@light-success @dark:text-@dark-success'
                  : '@light:text-@light-error @dark:text-@dark-error'
              }`"
            />
          </transition>
        </slot>
      </div>
    </slot>

    <transition
      enter-active-class="_veryfast animated fadeIn"
      leave-active-class="_veryfast animated fadeOut"
    >
      <!--
        @slot Description slot
      -->
      <slot
        v-if="description.length > 0"
        name="description"
      >
        <!-- Description -->
        <div :class="getElementCssClass('description')">
          <p>{{ description }}</p>
        </div>
      </slot>
    </transition>

    <transition
      enter-active-class="_veryfast animated fadeIn"
      leave-active-class="_veryfast animated fadeOut"
    >
      <!--
        @slot Error slot
      -->
      <slot
        v-if="error.length > 0"
        name="error"
      >
        <!-- Error message -->
        <div :class="getElementCssClass('error')">
          <p>{{ error }}</p>
        </div>
      </slot>
    </transition>

  </label>
</template>

<script>
import BaseInput from '@/components/commons/form/BaseInput.vue'
import Style from './style'

/**
 * **VInput** component
 *
 * See also [vue-tailwind TInput documentation](https://www.vue-tailwind.com/docs/text-input)
 */
export default {
  name: 'VInput',
  extends: BaseInput,
  props: {
    /**
     * value (to use v-model directive)
     *
     * See also how to [customize component v-model](https://vuejs.org/v2/guide/components-custom-events.html#Customizing-Component-v-model)
     */
    value: {
      type: String,
      default: ''
    },
    /**
     * lazyValidation
     */
    lazyValidation: {
      type: Function,
      default: null
    },
    /**
     * wait
     */
    wait: {
      type: Number,
      default: 1000
    },
    /**
     * min
     */
    minValue: {
      type: String,
      default: null
    },
    /**
     * max
     */
    maxValue: {
      type: [ String, Number ],
      default: null
    },
    /**
     * inputWidth
     */
    inputWidth: {
      type: [ String, Number ],
      default: null
    },
    /**
     * step
     */
    step: {
      type: [ String, Number ],
      default: null
    }
  },
  data () {
    return {
      timeOut: null,
      isLoading: false,
      /**
       * Local status: can be:
       * - null: the default value
       * - 'pending': the input v-model has changed but the lazy-validation callback is not yet called
       * - 'loading': the lazy-validation callback is running
       */
      localStatus: null
    }
  },
  computed: {
    /**
     * ⚠ We have to flatten nested object because Tinput original component requires
     * a one-level object as props for style
     * @returns {object} An object following VariantableOptions structure
     */
    tInputStyle: function () {
      return {
        fixedClasses: this.style.fixedClasses.input,
        classes: this.style.classes.input,
        variants: Object.keys(this.style.variants).reduce((obj, variant) => {
          obj[variant] = this.style.variants[variant].input
          return obj
        }, {})
      }
    }
  },
  watch: {
    vModel: function (to) {
      // Only if lazyValidation is defined
      if (this.lazyValidation) {
        this.waitFor()
      }
    }
  },
  methods: {
    /**
     * The native input event handler
     * @param {object} event - The event object
     */
    nativeInputHandler: function (event) {
      event.target.value = this.vModel = this.formatter(event.target.value, event)
    },
    /**
     * waitFor method
     * @return {void}
     */
    waitFor: function () {
      this.localStatus = 'pending'
      clearTimeout(this.timeOut) // Clear timeout
      this.timeOut = setTimeout(async () => {
        this.localStatus = 'loading'
        this.isLoading = true
        await this.lazyValidation()
        this.isLoading = false
        this.localStatus = null
      }, this.wait)
    }
  },
  // Variantable option
  style: Style
}
</script>
